#ifndef H_BD1D0F6F908CE246569B9A90A88F975B_Patrol_SPLTYPES_H
#define H_BD1D0F6F908CE246569B9A90A88F975B_Patrol_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_Patrol_.h"
#include "unique_identifier_msgs/msg/dds_opensplice/UUID_SplDcps.h"
#include "builtin_interfaces/msg/dds_opensplice/Time_SplDcps.h"



extern c_metaObject __Patrol__turtlebot3_msgs__load (c_base base);

extern c_metaObject __Patrol__turtlebot3_msgs_action__load (c_base base);

extern c_metaObject __Patrol__turtlebot3_msgs_action_dds___load (c_base base);

extern const char *turtlebot3_msgs_action_dds__Patrol_Goal__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Patrol_Goal__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Patrol_Goal__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Patrol_Goal___load (c_base base);
struct _turtlebot3_msgs_action_dds__Patrol_Goal_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Patrol_Goal___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Patrol_Goal_ *from, struct _turtlebot3_msgs_action_dds__Patrol_Goal_ *to);
extern  void __turtlebot3_msgs_action_dds__Patrol_Goal___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Patrol_Goal_ {
    c_float radius_;
};

extern const char *turtlebot3_msgs_action_dds__Patrol_SendGoal_Request__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Patrol_SendGoal_Request__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Patrol_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Patrol_SendGoal_Request___load (c_base base);
struct _turtlebot3_msgs_action_dds__Patrol_SendGoal_Request_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Patrol_SendGoal_Request___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Patrol_SendGoal_Request_ *from, struct _turtlebot3_msgs_action_dds__Patrol_SendGoal_Request_ *to);
extern  void __turtlebot3_msgs_action_dds__Patrol_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Patrol_SendGoal_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _turtlebot3_msgs_action_dds__Patrol_Goal_ goal_;
};

extern const char *turtlebot3_msgs_action_dds__Patrol_SendGoal_Response__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Patrol_SendGoal_Response__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Patrol_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Patrol_SendGoal_Response___load (c_base base);
struct _turtlebot3_msgs_action_dds__Patrol_SendGoal_Response_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Patrol_SendGoal_Response___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Patrol_SendGoal_Response_ *from, struct _turtlebot3_msgs_action_dds__Patrol_SendGoal_Response_ *to);
extern  void __turtlebot3_msgs_action_dds__Patrol_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Patrol_SendGoal_Response_ {
    c_bool accepted_;
    struct _builtin_interfaces_msg_dds__Time_ stamp_;
};

extern const char *turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Request__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Request__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Request__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Request___load (c_base base);
struct _turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Request_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Request___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Sample_Patrol_SendGoal_Request_ *from, struct _turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Request_ *to);
extern  void __turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Request___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _turtlebot3_msgs_action_dds__Patrol_SendGoal_Request_ request_;
};

extern const char *turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Response__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Response__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Response__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Response___load (c_base base);
struct _turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Response_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Response___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Sample_Patrol_SendGoal_Response_ *from, struct _turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Response_ *to);
extern  void __turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Response___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Sample_Patrol_SendGoal_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _turtlebot3_msgs_action_dds__Patrol_SendGoal_Response_ response_;
};

extern const char *turtlebot3_msgs_action_dds__Patrol_Result__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Patrol_Result__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Patrol_Result__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Patrol_Result___load (c_base base);
struct _turtlebot3_msgs_action_dds__Patrol_Result_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Patrol_Result___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Patrol_Result_ *from, struct _turtlebot3_msgs_action_dds__Patrol_Result_ *to);
extern  void __turtlebot3_msgs_action_dds__Patrol_Result___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Patrol_Result_ {
    c_bool success_;
};

extern const char *turtlebot3_msgs_action_dds__Patrol_GetResult_Request__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Patrol_GetResult_Request__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Patrol_GetResult_Request__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Patrol_GetResult_Request___load (c_base base);
struct _turtlebot3_msgs_action_dds__Patrol_GetResult_Request_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Patrol_GetResult_Request___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Patrol_GetResult_Request_ *from, struct _turtlebot3_msgs_action_dds__Patrol_GetResult_Request_ *to);
extern  void __turtlebot3_msgs_action_dds__Patrol_GetResult_Request___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Patrol_GetResult_Request_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
};

extern const char *turtlebot3_msgs_action_dds__Patrol_GetResult_Response__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Patrol_GetResult_Response__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Patrol_GetResult_Response__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Patrol_GetResult_Response___load (c_base base);
struct _turtlebot3_msgs_action_dds__Patrol_GetResult_Response_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Patrol_GetResult_Response___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Patrol_GetResult_Response_ *from, struct _turtlebot3_msgs_action_dds__Patrol_GetResult_Response_ *to);
extern  void __turtlebot3_msgs_action_dds__Patrol_GetResult_Response___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Patrol_GetResult_Response_ {
    c_octet status_;
    struct _turtlebot3_msgs_action_dds__Patrol_Result_ result_;
};

extern const char *turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Request__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Request__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Request__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Request___load (c_base base);
struct _turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Request_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Request___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Sample_Patrol_GetResult_Request_ *from, struct _turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Request_ *to);
extern  void __turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Request___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Request_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _turtlebot3_msgs_action_dds__Patrol_GetResult_Request_ request_;
};

extern const char *turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Response__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Response__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Response__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Response___load (c_base base);
struct _turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Response_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Response___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Sample_Patrol_GetResult_Response_ *from, struct _turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Response_ *to);
extern  void __turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Response___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Sample_Patrol_GetResult_Response_ {
    c_ulonglong client_guid_0_;
    c_ulonglong client_guid_1_;
    c_longlong sequence_number_;
    struct _turtlebot3_msgs_action_dds__Patrol_GetResult_Response_ response_;
};

extern const char *turtlebot3_msgs_action_dds__Patrol_Feedback__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Patrol_Feedback__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Patrol_Feedback__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Patrol_Feedback___load (c_base base);
struct _turtlebot3_msgs_action_dds__Patrol_Feedback_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Patrol_Feedback___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Patrol_Feedback_ *from, struct _turtlebot3_msgs_action_dds__Patrol_Feedback_ *to);
extern  void __turtlebot3_msgs_action_dds__Patrol_Feedback___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Patrol_Feedback_ {
    c_float left_time_;
};

extern const char *turtlebot3_msgs_action_dds__Patrol_FeedbackMessage__metaDescriptor[];
extern const int turtlebot3_msgs_action_dds__Patrol_FeedbackMessage__metaDescriptorArrLength;
extern const int turtlebot3_msgs_action_dds__Patrol_FeedbackMessage__metaDescriptorLength;
extern c_metaObject __turtlebot3_msgs_action_dds__Patrol_FeedbackMessage___load (c_base base);
struct _turtlebot3_msgs_action_dds__Patrol_FeedbackMessage_ ;
extern  v_copyin_result __turtlebot3_msgs_action_dds__Patrol_FeedbackMessage___copyIn(c_base base, const struct turtlebot3_msgs::action::dds_::Patrol_FeedbackMessage_ *from, struct _turtlebot3_msgs_action_dds__Patrol_FeedbackMessage_ *to);
extern  void __turtlebot3_msgs_action_dds__Patrol_FeedbackMessage___copyOut(const void *_from, void *_to);
struct _turtlebot3_msgs_action_dds__Patrol_FeedbackMessage_ {
    struct _unique_identifier_msgs_msg_dds__UUID_ goal_id_;
    struct _turtlebot3_msgs_action_dds__Patrol_Feedback_ feedback_;
};

#undef OS_API
#endif
