#ifndef _H_BD1D0F6F908CE246569B9A90A88F975B_Patrol_DCPS_H_
#define _H_BD1D0F6F908CE246569B9A90A88F975B_Patrol_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Patrol_.h"


namespace turtlebot3_msgs
{
    namespace action
    {
        namespace dds_
        {
            class Patrol_Goal_TypeSupportInterface;

            typedef Patrol_Goal_TypeSupportInterface * Patrol_Goal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Goal_TypeSupportInterface> Patrol_Goal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Patrol_Goal_TypeSupportInterface> Patrol_Goal_TypeSupportInterface_out;


            class Patrol_Goal_DataWriter;

            typedef Patrol_Goal_DataWriter * Patrol_Goal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Goal_DataWriter> Patrol_Goal_DataWriter_var;
            typedef DDS_DCPSInterface_out < Patrol_Goal_DataWriter> Patrol_Goal_DataWriter_out;


            class Patrol_Goal_DataReader;

            typedef Patrol_Goal_DataReader * Patrol_Goal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Goal_DataReader> Patrol_Goal_DataReader_var;
            typedef DDS_DCPSInterface_out < Patrol_Goal_DataReader> Patrol_Goal_DataReader_out;


            class Patrol_Goal_DataReaderView;

            typedef Patrol_Goal_DataReaderView * Patrol_Goal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Goal_DataReaderView> Patrol_Goal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Patrol_Goal_DataReaderView> Patrol_Goal_DataReaderView_out;

            struct Patrol_Goal_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Patrol_Goal_, struct Patrol_Goal_Seq_uniq_> Patrol_Goal_Seq;
            typedef DDS_DCPSSequence_var < Patrol_Goal_Seq> Patrol_Goal_Seq_var;
            typedef DDS_DCPSSequence_out < Patrol_Goal_Seq> Patrol_Goal_Seq_out;

            class  Patrol_Goal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Patrol_Goal_TypeSupportInterface_ptr _ptr_type;
                typedef Patrol_Goal_TypeSupportInterface_var _var_type;

                static Patrol_Goal_TypeSupportInterface_ptr _duplicate (Patrol_Goal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Goal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Goal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Goal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Goal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Patrol_Goal_TypeSupportInterface () {};
                ~Patrol_Goal_TypeSupportInterface () {};
            private:
                Patrol_Goal_TypeSupportInterface (const Patrol_Goal_TypeSupportInterface &);
                Patrol_Goal_TypeSupportInterface & operator = (const Patrol_Goal_TypeSupportInterface &);
            };

            class  Patrol_Goal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Patrol_Goal_DataWriter_ptr _ptr_type;
                typedef Patrol_Goal_DataWriter_var _var_type;

                static Patrol_Goal_DataWriter_ptr _duplicate (Patrol_Goal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Goal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Goal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Goal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Goal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Patrol_Goal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Patrol_Goal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Patrol_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Patrol_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Patrol_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Patrol_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Patrol_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Patrol_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Patrol_Goal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Patrol_Goal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Patrol_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_Goal_& instance_data) = 0;

            protected:
                Patrol_Goal_DataWriter () {};
                ~Patrol_Goal_DataWriter () {};
            private:
                Patrol_Goal_DataWriter (const Patrol_Goal_DataWriter &);
                Patrol_Goal_DataWriter & operator = (const Patrol_Goal_DataWriter &);
            };

            class  Patrol_Goal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Patrol_Goal_DataReader_ptr _ptr_type;
                typedef Patrol_Goal_DataReader_var _var_type;

                static Patrol_Goal_DataReader_ptr _duplicate (Patrol_Goal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Goal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Goal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Goal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Goal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_Goal_& instance) = 0;

            protected:
                Patrol_Goal_DataReader () {};
                ~Patrol_Goal_DataReader () {};
            private:
                Patrol_Goal_DataReader (const Patrol_Goal_DataReader &);
                Patrol_Goal_DataReader & operator = (const Patrol_Goal_DataReader &);
            };

            class  Patrol_Goal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Patrol_Goal_DataReaderView_ptr _ptr_type;
                typedef Patrol_Goal_DataReaderView_var _var_type;

                static Patrol_Goal_DataReaderView_ptr _duplicate (Patrol_Goal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Goal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Goal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Goal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Goal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_Goal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_Goal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_Goal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_Goal_& instance) = 0;

            protected:
                Patrol_Goal_DataReaderView () {};
                ~Patrol_Goal_DataReaderView () {};
            private:
                Patrol_Goal_DataReaderView (const Patrol_Goal_DataReaderView &);
                Patrol_Goal_DataReaderView & operator = (const Patrol_Goal_DataReaderView &);
            };
            class Patrol_SendGoal_Request_TypeSupportInterface;

            typedef Patrol_SendGoal_Request_TypeSupportInterface * Patrol_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Patrol_SendGoal_Request_TypeSupportInterface> Patrol_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Patrol_SendGoal_Request_TypeSupportInterface> Patrol_SendGoal_Request_TypeSupportInterface_out;


            class Patrol_SendGoal_Request_DataWriter;

            typedef Patrol_SendGoal_Request_DataWriter * Patrol_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Patrol_SendGoal_Request_DataWriter> Patrol_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Patrol_SendGoal_Request_DataWriter> Patrol_SendGoal_Request_DataWriter_out;


            class Patrol_SendGoal_Request_DataReader;

            typedef Patrol_SendGoal_Request_DataReader * Patrol_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Patrol_SendGoal_Request_DataReader> Patrol_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Patrol_SendGoal_Request_DataReader> Patrol_SendGoal_Request_DataReader_out;


            class Patrol_SendGoal_Request_DataReaderView;

            typedef Patrol_SendGoal_Request_DataReaderView * Patrol_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Patrol_SendGoal_Request_DataReaderView> Patrol_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Patrol_SendGoal_Request_DataReaderView> Patrol_SendGoal_Request_DataReaderView_out;

            struct Patrol_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Patrol_SendGoal_Request_, struct Patrol_SendGoal_Request_Seq_uniq_> Patrol_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Patrol_SendGoal_Request_Seq> Patrol_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Patrol_SendGoal_Request_Seq> Patrol_SendGoal_Request_Seq_out;

            class  Patrol_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Patrol_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Patrol_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Patrol_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Patrol_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Patrol_SendGoal_Request_TypeSupportInterface () {};
                ~Patrol_SendGoal_Request_TypeSupportInterface () {};
            private:
                Patrol_SendGoal_Request_TypeSupportInterface (const Patrol_SendGoal_Request_TypeSupportInterface &);
                Patrol_SendGoal_Request_TypeSupportInterface & operator = (const Patrol_SendGoal_Request_TypeSupportInterface &);
            };

            class  Patrol_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Patrol_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Patrol_SendGoal_Request_DataWriter_var _var_type;

                static Patrol_SendGoal_Request_DataWriter_ptr _duplicate (Patrol_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Patrol_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Patrol_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Patrol_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_SendGoal_Request_& instance_data) = 0;

            protected:
                Patrol_SendGoal_Request_DataWriter () {};
                ~Patrol_SendGoal_Request_DataWriter () {};
            private:
                Patrol_SendGoal_Request_DataWriter (const Patrol_SendGoal_Request_DataWriter &);
                Patrol_SendGoal_Request_DataWriter & operator = (const Patrol_SendGoal_Request_DataWriter &);
            };

            class  Patrol_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Patrol_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Patrol_SendGoal_Request_DataReader_var _var_type;

                static Patrol_SendGoal_Request_DataReader_ptr _duplicate (Patrol_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_SendGoal_Request_& instance) = 0;

            protected:
                Patrol_SendGoal_Request_DataReader () {};
                ~Patrol_SendGoal_Request_DataReader () {};
            private:
                Patrol_SendGoal_Request_DataReader (const Patrol_SendGoal_Request_DataReader &);
                Patrol_SendGoal_Request_DataReader & operator = (const Patrol_SendGoal_Request_DataReader &);
            };

            class  Patrol_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Patrol_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Patrol_SendGoal_Request_DataReaderView_var _var_type;

                static Patrol_SendGoal_Request_DataReaderView_ptr _duplicate (Patrol_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_SendGoal_Request_& instance) = 0;

            protected:
                Patrol_SendGoal_Request_DataReaderView () {};
                ~Patrol_SendGoal_Request_DataReaderView () {};
            private:
                Patrol_SendGoal_Request_DataReaderView (const Patrol_SendGoal_Request_DataReaderView &);
                Patrol_SendGoal_Request_DataReaderView & operator = (const Patrol_SendGoal_Request_DataReaderView &);
            };
            class Patrol_SendGoal_Response_TypeSupportInterface;

            typedef Patrol_SendGoal_Response_TypeSupportInterface * Patrol_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Patrol_SendGoal_Response_TypeSupportInterface> Patrol_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Patrol_SendGoal_Response_TypeSupportInterface> Patrol_SendGoal_Response_TypeSupportInterface_out;


            class Patrol_SendGoal_Response_DataWriter;

            typedef Patrol_SendGoal_Response_DataWriter * Patrol_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Patrol_SendGoal_Response_DataWriter> Patrol_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Patrol_SendGoal_Response_DataWriter> Patrol_SendGoal_Response_DataWriter_out;


            class Patrol_SendGoal_Response_DataReader;

            typedef Patrol_SendGoal_Response_DataReader * Patrol_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Patrol_SendGoal_Response_DataReader> Patrol_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Patrol_SendGoal_Response_DataReader> Patrol_SendGoal_Response_DataReader_out;


            class Patrol_SendGoal_Response_DataReaderView;

            typedef Patrol_SendGoal_Response_DataReaderView * Patrol_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Patrol_SendGoal_Response_DataReaderView> Patrol_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Patrol_SendGoal_Response_DataReaderView> Patrol_SendGoal_Response_DataReaderView_out;

            struct Patrol_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Patrol_SendGoal_Response_, struct Patrol_SendGoal_Response_Seq_uniq_> Patrol_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Patrol_SendGoal_Response_Seq> Patrol_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Patrol_SendGoal_Response_Seq> Patrol_SendGoal_Response_Seq_out;

            class  Patrol_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Patrol_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Patrol_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Patrol_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Patrol_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Patrol_SendGoal_Response_TypeSupportInterface () {};
                ~Patrol_SendGoal_Response_TypeSupportInterface () {};
            private:
                Patrol_SendGoal_Response_TypeSupportInterface (const Patrol_SendGoal_Response_TypeSupportInterface &);
                Patrol_SendGoal_Response_TypeSupportInterface & operator = (const Patrol_SendGoal_Response_TypeSupportInterface &);
            };

            class  Patrol_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Patrol_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Patrol_SendGoal_Response_DataWriter_var _var_type;

                static Patrol_SendGoal_Response_DataWriter_ptr _duplicate (Patrol_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Patrol_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Patrol_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Patrol_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_SendGoal_Response_& instance_data) = 0;

            protected:
                Patrol_SendGoal_Response_DataWriter () {};
                ~Patrol_SendGoal_Response_DataWriter () {};
            private:
                Patrol_SendGoal_Response_DataWriter (const Patrol_SendGoal_Response_DataWriter &);
                Patrol_SendGoal_Response_DataWriter & operator = (const Patrol_SendGoal_Response_DataWriter &);
            };

            class  Patrol_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Patrol_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Patrol_SendGoal_Response_DataReader_var _var_type;

                static Patrol_SendGoal_Response_DataReader_ptr _duplicate (Patrol_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_SendGoal_Response_& instance) = 0;

            protected:
                Patrol_SendGoal_Response_DataReader () {};
                ~Patrol_SendGoal_Response_DataReader () {};
            private:
                Patrol_SendGoal_Response_DataReader (const Patrol_SendGoal_Response_DataReader &);
                Patrol_SendGoal_Response_DataReader & operator = (const Patrol_SendGoal_Response_DataReader &);
            };

            class  Patrol_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Patrol_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Patrol_SendGoal_Response_DataReaderView_var _var_type;

                static Patrol_SendGoal_Response_DataReaderView_ptr _duplicate (Patrol_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_SendGoal_Response_& instance) = 0;

            protected:
                Patrol_SendGoal_Response_DataReaderView () {};
                ~Patrol_SendGoal_Response_DataReaderView () {};
            private:
                Patrol_SendGoal_Response_DataReaderView (const Patrol_SendGoal_Response_DataReaderView &);
                Patrol_SendGoal_Response_DataReaderView & operator = (const Patrol_SendGoal_Response_DataReaderView &);
            };
            class Sample_Patrol_SendGoal_Request_TypeSupportInterface;

            typedef Sample_Patrol_SendGoal_Request_TypeSupportInterface * Sample_Patrol_SendGoal_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_SendGoal_Request_TypeSupportInterface> Sample_Patrol_SendGoal_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_SendGoal_Request_TypeSupportInterface> Sample_Patrol_SendGoal_Request_TypeSupportInterface_out;


            class Sample_Patrol_SendGoal_Request_DataWriter;

            typedef Sample_Patrol_SendGoal_Request_DataWriter * Sample_Patrol_SendGoal_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_SendGoal_Request_DataWriter> Sample_Patrol_SendGoal_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_SendGoal_Request_DataWriter> Sample_Patrol_SendGoal_Request_DataWriter_out;


            class Sample_Patrol_SendGoal_Request_DataReader;

            typedef Sample_Patrol_SendGoal_Request_DataReader * Sample_Patrol_SendGoal_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_SendGoal_Request_DataReader> Sample_Patrol_SendGoal_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_SendGoal_Request_DataReader> Sample_Patrol_SendGoal_Request_DataReader_out;


            class Sample_Patrol_SendGoal_Request_DataReaderView;

            typedef Sample_Patrol_SendGoal_Request_DataReaderView * Sample_Patrol_SendGoal_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_SendGoal_Request_DataReaderView> Sample_Patrol_SendGoal_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_SendGoal_Request_DataReaderView> Sample_Patrol_SendGoal_Request_DataReaderView_out;

            struct Sample_Patrol_SendGoal_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Patrol_SendGoal_Request_, struct Sample_Patrol_SendGoal_Request_Seq_uniq_> Sample_Patrol_SendGoal_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Patrol_SendGoal_Request_Seq> Sample_Patrol_SendGoal_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Patrol_SendGoal_Request_Seq> Sample_Patrol_SendGoal_Request_Seq_out;

            class  Sample_Patrol_SendGoal_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Patrol_SendGoal_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Patrol_SendGoal_Request_TypeSupportInterface_var _var_type;

                static Sample_Patrol_SendGoal_Request_TypeSupportInterface_ptr _duplicate (Sample_Patrol_SendGoal_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_SendGoal_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_SendGoal_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Patrol_SendGoal_Request_TypeSupportInterface () {};
                ~Sample_Patrol_SendGoal_Request_TypeSupportInterface () {};
            private:
                Sample_Patrol_SendGoal_Request_TypeSupportInterface (const Sample_Patrol_SendGoal_Request_TypeSupportInterface &);
                Sample_Patrol_SendGoal_Request_TypeSupportInterface & operator = (const Sample_Patrol_SendGoal_Request_TypeSupportInterface &);
            };

            class  Sample_Patrol_SendGoal_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Patrol_SendGoal_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Patrol_SendGoal_Request_DataWriter_var _var_type;

                static Sample_Patrol_SendGoal_Request_DataWriter_ptr _duplicate (Sample_Patrol_SendGoal_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_SendGoal_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_SendGoal_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Patrol_SendGoal_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Patrol_SendGoal_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Patrol_SendGoal_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_SendGoal_Request_& instance_data) = 0;

            protected:
                Sample_Patrol_SendGoal_Request_DataWriter () {};
                ~Sample_Patrol_SendGoal_Request_DataWriter () {};
            private:
                Sample_Patrol_SendGoal_Request_DataWriter (const Sample_Patrol_SendGoal_Request_DataWriter &);
                Sample_Patrol_SendGoal_Request_DataWriter & operator = (const Sample_Patrol_SendGoal_Request_DataWriter &);
            };

            class  Sample_Patrol_SendGoal_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Patrol_SendGoal_Request_DataReader_ptr _ptr_type;
                typedef Sample_Patrol_SendGoal_Request_DataReader_var _var_type;

                static Sample_Patrol_SendGoal_Request_DataReader_ptr _duplicate (Sample_Patrol_SendGoal_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_SendGoal_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_SendGoal_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Patrol_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Patrol_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_SendGoal_Request_& instance) = 0;

            protected:
                Sample_Patrol_SendGoal_Request_DataReader () {};
                ~Sample_Patrol_SendGoal_Request_DataReader () {};
            private:
                Sample_Patrol_SendGoal_Request_DataReader (const Sample_Patrol_SendGoal_Request_DataReader &);
                Sample_Patrol_SendGoal_Request_DataReader & operator = (const Sample_Patrol_SendGoal_Request_DataReader &);
            };

            class  Sample_Patrol_SendGoal_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Patrol_SendGoal_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Patrol_SendGoal_Request_DataReaderView_var _var_type;

                static Sample_Patrol_SendGoal_Request_DataReaderView_ptr _duplicate (Sample_Patrol_SendGoal_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_SendGoal_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_SendGoal_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Patrol_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Patrol_SendGoal_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Patrol_SendGoal_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_SendGoal_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_SendGoal_Request_& instance) = 0;

            protected:
                Sample_Patrol_SendGoal_Request_DataReaderView () {};
                ~Sample_Patrol_SendGoal_Request_DataReaderView () {};
            private:
                Sample_Patrol_SendGoal_Request_DataReaderView (const Sample_Patrol_SendGoal_Request_DataReaderView &);
                Sample_Patrol_SendGoal_Request_DataReaderView & operator = (const Sample_Patrol_SendGoal_Request_DataReaderView &);
            };
            class Sample_Patrol_SendGoal_Response_TypeSupportInterface;

            typedef Sample_Patrol_SendGoal_Response_TypeSupportInterface * Sample_Patrol_SendGoal_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_SendGoal_Response_TypeSupportInterface> Sample_Patrol_SendGoal_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_SendGoal_Response_TypeSupportInterface> Sample_Patrol_SendGoal_Response_TypeSupportInterface_out;


            class Sample_Patrol_SendGoal_Response_DataWriter;

            typedef Sample_Patrol_SendGoal_Response_DataWriter * Sample_Patrol_SendGoal_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_SendGoal_Response_DataWriter> Sample_Patrol_SendGoal_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_SendGoal_Response_DataWriter> Sample_Patrol_SendGoal_Response_DataWriter_out;


            class Sample_Patrol_SendGoal_Response_DataReader;

            typedef Sample_Patrol_SendGoal_Response_DataReader * Sample_Patrol_SendGoal_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_SendGoal_Response_DataReader> Sample_Patrol_SendGoal_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_SendGoal_Response_DataReader> Sample_Patrol_SendGoal_Response_DataReader_out;


            class Sample_Patrol_SendGoal_Response_DataReaderView;

            typedef Sample_Patrol_SendGoal_Response_DataReaderView * Sample_Patrol_SendGoal_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_SendGoal_Response_DataReaderView> Sample_Patrol_SendGoal_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_SendGoal_Response_DataReaderView> Sample_Patrol_SendGoal_Response_DataReaderView_out;

            struct Sample_Patrol_SendGoal_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Patrol_SendGoal_Response_, struct Sample_Patrol_SendGoal_Response_Seq_uniq_> Sample_Patrol_SendGoal_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Patrol_SendGoal_Response_Seq> Sample_Patrol_SendGoal_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Patrol_SendGoal_Response_Seq> Sample_Patrol_SendGoal_Response_Seq_out;

            class  Sample_Patrol_SendGoal_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Patrol_SendGoal_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Patrol_SendGoal_Response_TypeSupportInterface_var _var_type;

                static Sample_Patrol_SendGoal_Response_TypeSupportInterface_ptr _duplicate (Sample_Patrol_SendGoal_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_SendGoal_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_SendGoal_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Patrol_SendGoal_Response_TypeSupportInterface () {};
                ~Sample_Patrol_SendGoal_Response_TypeSupportInterface () {};
            private:
                Sample_Patrol_SendGoal_Response_TypeSupportInterface (const Sample_Patrol_SendGoal_Response_TypeSupportInterface &);
                Sample_Patrol_SendGoal_Response_TypeSupportInterface & operator = (const Sample_Patrol_SendGoal_Response_TypeSupportInterface &);
            };

            class  Sample_Patrol_SendGoal_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Patrol_SendGoal_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Patrol_SendGoal_Response_DataWriter_var _var_type;

                static Sample_Patrol_SendGoal_Response_DataWriter_ptr _duplicate (Sample_Patrol_SendGoal_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_SendGoal_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_SendGoal_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Patrol_SendGoal_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Patrol_SendGoal_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Patrol_SendGoal_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_SendGoal_Response_& instance_data) = 0;

            protected:
                Sample_Patrol_SendGoal_Response_DataWriter () {};
                ~Sample_Patrol_SendGoal_Response_DataWriter () {};
            private:
                Sample_Patrol_SendGoal_Response_DataWriter (const Sample_Patrol_SendGoal_Response_DataWriter &);
                Sample_Patrol_SendGoal_Response_DataWriter & operator = (const Sample_Patrol_SendGoal_Response_DataWriter &);
            };

            class  Sample_Patrol_SendGoal_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Patrol_SendGoal_Response_DataReader_ptr _ptr_type;
                typedef Sample_Patrol_SendGoal_Response_DataReader_var _var_type;

                static Sample_Patrol_SendGoal_Response_DataReader_ptr _duplicate (Sample_Patrol_SendGoal_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_SendGoal_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_SendGoal_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Patrol_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Patrol_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_SendGoal_Response_& instance) = 0;

            protected:
                Sample_Patrol_SendGoal_Response_DataReader () {};
                ~Sample_Patrol_SendGoal_Response_DataReader () {};
            private:
                Sample_Patrol_SendGoal_Response_DataReader (const Sample_Patrol_SendGoal_Response_DataReader &);
                Sample_Patrol_SendGoal_Response_DataReader & operator = (const Sample_Patrol_SendGoal_Response_DataReader &);
            };

            class  Sample_Patrol_SendGoal_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Patrol_SendGoal_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Patrol_SendGoal_Response_DataReaderView_var _var_type;

                static Sample_Patrol_SendGoal_Response_DataReaderView_ptr _duplicate (Sample_Patrol_SendGoal_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_SendGoal_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_SendGoal_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_SendGoal_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Patrol_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Patrol_SendGoal_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Patrol_SendGoal_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_SendGoal_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_SendGoal_Response_& instance) = 0;

            protected:
                Sample_Patrol_SendGoal_Response_DataReaderView () {};
                ~Sample_Patrol_SendGoal_Response_DataReaderView () {};
            private:
                Sample_Patrol_SendGoal_Response_DataReaderView (const Sample_Patrol_SendGoal_Response_DataReaderView &);
                Sample_Patrol_SendGoal_Response_DataReaderView & operator = (const Sample_Patrol_SendGoal_Response_DataReaderView &);
            };
            class Patrol_Result_TypeSupportInterface;

            typedef Patrol_Result_TypeSupportInterface * Patrol_Result_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Result_TypeSupportInterface> Patrol_Result_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Patrol_Result_TypeSupportInterface> Patrol_Result_TypeSupportInterface_out;


            class Patrol_Result_DataWriter;

            typedef Patrol_Result_DataWriter * Patrol_Result_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Result_DataWriter> Patrol_Result_DataWriter_var;
            typedef DDS_DCPSInterface_out < Patrol_Result_DataWriter> Patrol_Result_DataWriter_out;


            class Patrol_Result_DataReader;

            typedef Patrol_Result_DataReader * Patrol_Result_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Result_DataReader> Patrol_Result_DataReader_var;
            typedef DDS_DCPSInterface_out < Patrol_Result_DataReader> Patrol_Result_DataReader_out;


            class Patrol_Result_DataReaderView;

            typedef Patrol_Result_DataReaderView * Patrol_Result_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Result_DataReaderView> Patrol_Result_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Patrol_Result_DataReaderView> Patrol_Result_DataReaderView_out;

            struct Patrol_Result_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Patrol_Result_, struct Patrol_Result_Seq_uniq_> Patrol_Result_Seq;
            typedef DDS_DCPSSequence_var < Patrol_Result_Seq> Patrol_Result_Seq_var;
            typedef DDS_DCPSSequence_out < Patrol_Result_Seq> Patrol_Result_Seq_out;

            class  Patrol_Result_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Patrol_Result_TypeSupportInterface_ptr _ptr_type;
                typedef Patrol_Result_TypeSupportInterface_var _var_type;

                static Patrol_Result_TypeSupportInterface_ptr _duplicate (Patrol_Result_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Result_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Result_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Result_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Result_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Patrol_Result_TypeSupportInterface () {};
                ~Patrol_Result_TypeSupportInterface () {};
            private:
                Patrol_Result_TypeSupportInterface (const Patrol_Result_TypeSupportInterface &);
                Patrol_Result_TypeSupportInterface & operator = (const Patrol_Result_TypeSupportInterface &);
            };

            class  Patrol_Result_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Patrol_Result_DataWriter_ptr _ptr_type;
                typedef Patrol_Result_DataWriter_var _var_type;

                static Patrol_Result_DataWriter_ptr _duplicate (Patrol_Result_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Result_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Result_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Result_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Result_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Patrol_Result_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Patrol_Result_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Patrol_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Patrol_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Patrol_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Patrol_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Patrol_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Patrol_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Patrol_Result_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Patrol_Result_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Patrol_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_Result_& instance_data) = 0;

            protected:
                Patrol_Result_DataWriter () {};
                ~Patrol_Result_DataWriter () {};
            private:
                Patrol_Result_DataWriter (const Patrol_Result_DataWriter &);
                Patrol_Result_DataWriter & operator = (const Patrol_Result_DataWriter &);
            };

            class  Patrol_Result_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Patrol_Result_DataReader_ptr _ptr_type;
                typedef Patrol_Result_DataReader_var _var_type;

                static Patrol_Result_DataReader_ptr _duplicate (Patrol_Result_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Result_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Result_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Result_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Result_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_Result_& instance) = 0;

            protected:
                Patrol_Result_DataReader () {};
                ~Patrol_Result_DataReader () {};
            private:
                Patrol_Result_DataReader (const Patrol_Result_DataReader &);
                Patrol_Result_DataReader & operator = (const Patrol_Result_DataReader &);
            };

            class  Patrol_Result_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Patrol_Result_DataReaderView_ptr _ptr_type;
                typedef Patrol_Result_DataReaderView_var _var_type;

                static Patrol_Result_DataReaderView_ptr _duplicate (Patrol_Result_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Result_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Result_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Result_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Result_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_Result_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_Result_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_Result_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_Result_& instance) = 0;

            protected:
                Patrol_Result_DataReaderView () {};
                ~Patrol_Result_DataReaderView () {};
            private:
                Patrol_Result_DataReaderView (const Patrol_Result_DataReaderView &);
                Patrol_Result_DataReaderView & operator = (const Patrol_Result_DataReaderView &);
            };
            class Patrol_GetResult_Request_TypeSupportInterface;

            typedef Patrol_GetResult_Request_TypeSupportInterface * Patrol_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Patrol_GetResult_Request_TypeSupportInterface> Patrol_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Patrol_GetResult_Request_TypeSupportInterface> Patrol_GetResult_Request_TypeSupportInterface_out;


            class Patrol_GetResult_Request_DataWriter;

            typedef Patrol_GetResult_Request_DataWriter * Patrol_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Patrol_GetResult_Request_DataWriter> Patrol_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Patrol_GetResult_Request_DataWriter> Patrol_GetResult_Request_DataWriter_out;


            class Patrol_GetResult_Request_DataReader;

            typedef Patrol_GetResult_Request_DataReader * Patrol_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Patrol_GetResult_Request_DataReader> Patrol_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Patrol_GetResult_Request_DataReader> Patrol_GetResult_Request_DataReader_out;


            class Patrol_GetResult_Request_DataReaderView;

            typedef Patrol_GetResult_Request_DataReaderView * Patrol_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Patrol_GetResult_Request_DataReaderView> Patrol_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Patrol_GetResult_Request_DataReaderView> Patrol_GetResult_Request_DataReaderView_out;

            struct Patrol_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Patrol_GetResult_Request_, struct Patrol_GetResult_Request_Seq_uniq_> Patrol_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Patrol_GetResult_Request_Seq> Patrol_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Patrol_GetResult_Request_Seq> Patrol_GetResult_Request_Seq_out;

            class  Patrol_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Patrol_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Patrol_GetResult_Request_TypeSupportInterface_var _var_type;

                static Patrol_GetResult_Request_TypeSupportInterface_ptr _duplicate (Patrol_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Patrol_GetResult_Request_TypeSupportInterface () {};
                ~Patrol_GetResult_Request_TypeSupportInterface () {};
            private:
                Patrol_GetResult_Request_TypeSupportInterface (const Patrol_GetResult_Request_TypeSupportInterface &);
                Patrol_GetResult_Request_TypeSupportInterface & operator = (const Patrol_GetResult_Request_TypeSupportInterface &);
            };

            class  Patrol_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Patrol_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Patrol_GetResult_Request_DataWriter_var _var_type;

                static Patrol_GetResult_Request_DataWriter_ptr _duplicate (Patrol_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Patrol_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Patrol_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Patrol_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Patrol_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Patrol_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Patrol_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Patrol_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Patrol_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Patrol_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Patrol_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Patrol_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_GetResult_Request_& instance_data) = 0;

            protected:
                Patrol_GetResult_Request_DataWriter () {};
                ~Patrol_GetResult_Request_DataWriter () {};
            private:
                Patrol_GetResult_Request_DataWriter (const Patrol_GetResult_Request_DataWriter &);
                Patrol_GetResult_Request_DataWriter & operator = (const Patrol_GetResult_Request_DataWriter &);
            };

            class  Patrol_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Patrol_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Patrol_GetResult_Request_DataReader_var _var_type;

                static Patrol_GetResult_Request_DataReader_ptr _duplicate (Patrol_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_GetResult_Request_& instance) = 0;

            protected:
                Patrol_GetResult_Request_DataReader () {};
                ~Patrol_GetResult_Request_DataReader () {};
            private:
                Patrol_GetResult_Request_DataReader (const Patrol_GetResult_Request_DataReader &);
                Patrol_GetResult_Request_DataReader & operator = (const Patrol_GetResult_Request_DataReader &);
            };

            class  Patrol_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Patrol_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Patrol_GetResult_Request_DataReaderView_var _var_type;

                static Patrol_GetResult_Request_DataReaderView_ptr _duplicate (Patrol_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_GetResult_Request_& instance) = 0;

            protected:
                Patrol_GetResult_Request_DataReaderView () {};
                ~Patrol_GetResult_Request_DataReaderView () {};
            private:
                Patrol_GetResult_Request_DataReaderView (const Patrol_GetResult_Request_DataReaderView &);
                Patrol_GetResult_Request_DataReaderView & operator = (const Patrol_GetResult_Request_DataReaderView &);
            };
            class Patrol_GetResult_Response_TypeSupportInterface;

            typedef Patrol_GetResult_Response_TypeSupportInterface * Patrol_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Patrol_GetResult_Response_TypeSupportInterface> Patrol_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Patrol_GetResult_Response_TypeSupportInterface> Patrol_GetResult_Response_TypeSupportInterface_out;


            class Patrol_GetResult_Response_DataWriter;

            typedef Patrol_GetResult_Response_DataWriter * Patrol_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Patrol_GetResult_Response_DataWriter> Patrol_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Patrol_GetResult_Response_DataWriter> Patrol_GetResult_Response_DataWriter_out;


            class Patrol_GetResult_Response_DataReader;

            typedef Patrol_GetResult_Response_DataReader * Patrol_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Patrol_GetResult_Response_DataReader> Patrol_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Patrol_GetResult_Response_DataReader> Patrol_GetResult_Response_DataReader_out;


            class Patrol_GetResult_Response_DataReaderView;

            typedef Patrol_GetResult_Response_DataReaderView * Patrol_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Patrol_GetResult_Response_DataReaderView> Patrol_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Patrol_GetResult_Response_DataReaderView> Patrol_GetResult_Response_DataReaderView_out;

            struct Patrol_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Patrol_GetResult_Response_, struct Patrol_GetResult_Response_Seq_uniq_> Patrol_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Patrol_GetResult_Response_Seq> Patrol_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Patrol_GetResult_Response_Seq> Patrol_GetResult_Response_Seq_out;

            class  Patrol_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Patrol_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Patrol_GetResult_Response_TypeSupportInterface_var _var_type;

                static Patrol_GetResult_Response_TypeSupportInterface_ptr _duplicate (Patrol_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Patrol_GetResult_Response_TypeSupportInterface () {};
                ~Patrol_GetResult_Response_TypeSupportInterface () {};
            private:
                Patrol_GetResult_Response_TypeSupportInterface (const Patrol_GetResult_Response_TypeSupportInterface &);
                Patrol_GetResult_Response_TypeSupportInterface & operator = (const Patrol_GetResult_Response_TypeSupportInterface &);
            };

            class  Patrol_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Patrol_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Patrol_GetResult_Response_DataWriter_var _var_type;

                static Patrol_GetResult_Response_DataWriter_ptr _duplicate (Patrol_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Patrol_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Patrol_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Patrol_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Patrol_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Patrol_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Patrol_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Patrol_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Patrol_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Patrol_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Patrol_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Patrol_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_GetResult_Response_& instance_data) = 0;

            protected:
                Patrol_GetResult_Response_DataWriter () {};
                ~Patrol_GetResult_Response_DataWriter () {};
            private:
                Patrol_GetResult_Response_DataWriter (const Patrol_GetResult_Response_DataWriter &);
                Patrol_GetResult_Response_DataWriter & operator = (const Patrol_GetResult_Response_DataWriter &);
            };

            class  Patrol_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Patrol_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Patrol_GetResult_Response_DataReader_var _var_type;

                static Patrol_GetResult_Response_DataReader_ptr _duplicate (Patrol_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_GetResult_Response_& instance) = 0;

            protected:
                Patrol_GetResult_Response_DataReader () {};
                ~Patrol_GetResult_Response_DataReader () {};
            private:
                Patrol_GetResult_Response_DataReader (const Patrol_GetResult_Response_DataReader &);
                Patrol_GetResult_Response_DataReader & operator = (const Patrol_GetResult_Response_DataReader &);
            };

            class  Patrol_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Patrol_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Patrol_GetResult_Response_DataReaderView_var _var_type;

                static Patrol_GetResult_Response_DataReaderView_ptr _duplicate (Patrol_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_GetResult_Response_& instance) = 0;

            protected:
                Patrol_GetResult_Response_DataReaderView () {};
                ~Patrol_GetResult_Response_DataReaderView () {};
            private:
                Patrol_GetResult_Response_DataReaderView (const Patrol_GetResult_Response_DataReaderView &);
                Patrol_GetResult_Response_DataReaderView & operator = (const Patrol_GetResult_Response_DataReaderView &);
            };
            class Sample_Patrol_GetResult_Request_TypeSupportInterface;

            typedef Sample_Patrol_GetResult_Request_TypeSupportInterface * Sample_Patrol_GetResult_Request_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_GetResult_Request_TypeSupportInterface> Sample_Patrol_GetResult_Request_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_GetResult_Request_TypeSupportInterface> Sample_Patrol_GetResult_Request_TypeSupportInterface_out;


            class Sample_Patrol_GetResult_Request_DataWriter;

            typedef Sample_Patrol_GetResult_Request_DataWriter * Sample_Patrol_GetResult_Request_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_GetResult_Request_DataWriter> Sample_Patrol_GetResult_Request_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_GetResult_Request_DataWriter> Sample_Patrol_GetResult_Request_DataWriter_out;


            class Sample_Patrol_GetResult_Request_DataReader;

            typedef Sample_Patrol_GetResult_Request_DataReader * Sample_Patrol_GetResult_Request_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_GetResult_Request_DataReader> Sample_Patrol_GetResult_Request_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_GetResult_Request_DataReader> Sample_Patrol_GetResult_Request_DataReader_out;


            class Sample_Patrol_GetResult_Request_DataReaderView;

            typedef Sample_Patrol_GetResult_Request_DataReaderView * Sample_Patrol_GetResult_Request_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_GetResult_Request_DataReaderView> Sample_Patrol_GetResult_Request_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_GetResult_Request_DataReaderView> Sample_Patrol_GetResult_Request_DataReaderView_out;

            struct Sample_Patrol_GetResult_Request_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Patrol_GetResult_Request_, struct Sample_Patrol_GetResult_Request_Seq_uniq_> Sample_Patrol_GetResult_Request_Seq;
            typedef DDS_DCPSSequence_var < Sample_Patrol_GetResult_Request_Seq> Sample_Patrol_GetResult_Request_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Patrol_GetResult_Request_Seq> Sample_Patrol_GetResult_Request_Seq_out;

            class  Sample_Patrol_GetResult_Request_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Patrol_GetResult_Request_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Patrol_GetResult_Request_TypeSupportInterface_var _var_type;

                static Sample_Patrol_GetResult_Request_TypeSupportInterface_ptr _duplicate (Sample_Patrol_GetResult_Request_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_GetResult_Request_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Request_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Request_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_GetResult_Request_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Patrol_GetResult_Request_TypeSupportInterface () {};
                ~Sample_Patrol_GetResult_Request_TypeSupportInterface () {};
            private:
                Sample_Patrol_GetResult_Request_TypeSupportInterface (const Sample_Patrol_GetResult_Request_TypeSupportInterface &);
                Sample_Patrol_GetResult_Request_TypeSupportInterface & operator = (const Sample_Patrol_GetResult_Request_TypeSupportInterface &);
            };

            class  Sample_Patrol_GetResult_Request_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Patrol_GetResult_Request_DataWriter_ptr _ptr_type;
                typedef Sample_Patrol_GetResult_Request_DataWriter_var _var_type;

                static Sample_Patrol_GetResult_Request_DataWriter_ptr _duplicate (Sample_Patrol_GetResult_Request_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_GetResult_Request_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Request_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Request_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_GetResult_Request_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Patrol_GetResult_Request_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Patrol_GetResult_Request_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Patrol_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Patrol_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Patrol_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Patrol_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Patrol_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Patrol_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Patrol_GetResult_Request_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Patrol_GetResult_Request_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_GetResult_Request_& instance_data) = 0;

            protected:
                Sample_Patrol_GetResult_Request_DataWriter () {};
                ~Sample_Patrol_GetResult_Request_DataWriter () {};
            private:
                Sample_Patrol_GetResult_Request_DataWriter (const Sample_Patrol_GetResult_Request_DataWriter &);
                Sample_Patrol_GetResult_Request_DataWriter & operator = (const Sample_Patrol_GetResult_Request_DataWriter &);
            };

            class  Sample_Patrol_GetResult_Request_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Patrol_GetResult_Request_DataReader_ptr _ptr_type;
                typedef Sample_Patrol_GetResult_Request_DataReader_var _var_type;

                static Sample_Patrol_GetResult_Request_DataReader_ptr _duplicate (Sample_Patrol_GetResult_Request_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_GetResult_Request_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Request_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Request_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_GetResult_Request_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Patrol_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Patrol_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_GetResult_Request_& instance) = 0;

            protected:
                Sample_Patrol_GetResult_Request_DataReader () {};
                ~Sample_Patrol_GetResult_Request_DataReader () {};
            private:
                Sample_Patrol_GetResult_Request_DataReader (const Sample_Patrol_GetResult_Request_DataReader &);
                Sample_Patrol_GetResult_Request_DataReader & operator = (const Sample_Patrol_GetResult_Request_DataReader &);
            };

            class  Sample_Patrol_GetResult_Request_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Patrol_GetResult_Request_DataReaderView_ptr _ptr_type;
                typedef Sample_Patrol_GetResult_Request_DataReaderView_var _var_type;

                static Sample_Patrol_GetResult_Request_DataReaderView_ptr _duplicate (Sample_Patrol_GetResult_Request_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_GetResult_Request_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Request_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Request_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_GetResult_Request_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Patrol_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Patrol_GetResult_Request_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Patrol_GetResult_Request_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_GetResult_Request_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_GetResult_Request_& instance) = 0;

            protected:
                Sample_Patrol_GetResult_Request_DataReaderView () {};
                ~Sample_Patrol_GetResult_Request_DataReaderView () {};
            private:
                Sample_Patrol_GetResult_Request_DataReaderView (const Sample_Patrol_GetResult_Request_DataReaderView &);
                Sample_Patrol_GetResult_Request_DataReaderView & operator = (const Sample_Patrol_GetResult_Request_DataReaderView &);
            };
            class Sample_Patrol_GetResult_Response_TypeSupportInterface;

            typedef Sample_Patrol_GetResult_Response_TypeSupportInterface * Sample_Patrol_GetResult_Response_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_GetResult_Response_TypeSupportInterface> Sample_Patrol_GetResult_Response_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_GetResult_Response_TypeSupportInterface> Sample_Patrol_GetResult_Response_TypeSupportInterface_out;


            class Sample_Patrol_GetResult_Response_DataWriter;

            typedef Sample_Patrol_GetResult_Response_DataWriter * Sample_Patrol_GetResult_Response_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_GetResult_Response_DataWriter> Sample_Patrol_GetResult_Response_DataWriter_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_GetResult_Response_DataWriter> Sample_Patrol_GetResult_Response_DataWriter_out;


            class Sample_Patrol_GetResult_Response_DataReader;

            typedef Sample_Patrol_GetResult_Response_DataReader * Sample_Patrol_GetResult_Response_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_GetResult_Response_DataReader> Sample_Patrol_GetResult_Response_DataReader_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_GetResult_Response_DataReader> Sample_Patrol_GetResult_Response_DataReader_out;


            class Sample_Patrol_GetResult_Response_DataReaderView;

            typedef Sample_Patrol_GetResult_Response_DataReaderView * Sample_Patrol_GetResult_Response_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Sample_Patrol_GetResult_Response_DataReaderView> Sample_Patrol_GetResult_Response_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Sample_Patrol_GetResult_Response_DataReaderView> Sample_Patrol_GetResult_Response_DataReaderView_out;

            struct Sample_Patrol_GetResult_Response_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Sample_Patrol_GetResult_Response_, struct Sample_Patrol_GetResult_Response_Seq_uniq_> Sample_Patrol_GetResult_Response_Seq;
            typedef DDS_DCPSSequence_var < Sample_Patrol_GetResult_Response_Seq> Sample_Patrol_GetResult_Response_Seq_var;
            typedef DDS_DCPSSequence_out < Sample_Patrol_GetResult_Response_Seq> Sample_Patrol_GetResult_Response_Seq_out;

            class  Sample_Patrol_GetResult_Response_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Sample_Patrol_GetResult_Response_TypeSupportInterface_ptr _ptr_type;
                typedef Sample_Patrol_GetResult_Response_TypeSupportInterface_var _var_type;

                static Sample_Patrol_GetResult_Response_TypeSupportInterface_ptr _duplicate (Sample_Patrol_GetResult_Response_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_GetResult_Response_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Response_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Response_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_GetResult_Response_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Sample_Patrol_GetResult_Response_TypeSupportInterface () {};
                ~Sample_Patrol_GetResult_Response_TypeSupportInterface () {};
            private:
                Sample_Patrol_GetResult_Response_TypeSupportInterface (const Sample_Patrol_GetResult_Response_TypeSupportInterface &);
                Sample_Patrol_GetResult_Response_TypeSupportInterface & operator = (const Sample_Patrol_GetResult_Response_TypeSupportInterface &);
            };

            class  Sample_Patrol_GetResult_Response_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Sample_Patrol_GetResult_Response_DataWriter_ptr _ptr_type;
                typedef Sample_Patrol_GetResult_Response_DataWriter_var _var_type;

                static Sample_Patrol_GetResult_Response_DataWriter_ptr _duplicate (Sample_Patrol_GetResult_Response_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_GetResult_Response_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Response_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Response_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_GetResult_Response_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Sample_Patrol_GetResult_Response_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Sample_Patrol_GetResult_Response_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Sample_Patrol_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Sample_Patrol_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Sample_Patrol_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Sample_Patrol_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Sample_Patrol_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Sample_Patrol_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Sample_Patrol_GetResult_Response_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Sample_Patrol_GetResult_Response_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_GetResult_Response_& instance_data) = 0;

            protected:
                Sample_Patrol_GetResult_Response_DataWriter () {};
                ~Sample_Patrol_GetResult_Response_DataWriter () {};
            private:
                Sample_Patrol_GetResult_Response_DataWriter (const Sample_Patrol_GetResult_Response_DataWriter &);
                Sample_Patrol_GetResult_Response_DataWriter & operator = (const Sample_Patrol_GetResult_Response_DataWriter &);
            };

            class  Sample_Patrol_GetResult_Response_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Sample_Patrol_GetResult_Response_DataReader_ptr _ptr_type;
                typedef Sample_Patrol_GetResult_Response_DataReader_var _var_type;

                static Sample_Patrol_GetResult_Response_DataReader_ptr _duplicate (Sample_Patrol_GetResult_Response_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_GetResult_Response_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Response_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Response_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_GetResult_Response_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Patrol_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Patrol_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_GetResult_Response_& instance) = 0;

            protected:
                Sample_Patrol_GetResult_Response_DataReader () {};
                ~Sample_Patrol_GetResult_Response_DataReader () {};
            private:
                Sample_Patrol_GetResult_Response_DataReader (const Sample_Patrol_GetResult_Response_DataReader &);
                Sample_Patrol_GetResult_Response_DataReader & operator = (const Sample_Patrol_GetResult_Response_DataReader &);
            };

            class  Sample_Patrol_GetResult_Response_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Sample_Patrol_GetResult_Response_DataReaderView_ptr _ptr_type;
                typedef Sample_Patrol_GetResult_Response_DataReaderView_var _var_type;

                static Sample_Patrol_GetResult_Response_DataReaderView_ptr _duplicate (Sample_Patrol_GetResult_Response_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Sample_Patrol_GetResult_Response_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Response_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Sample_Patrol_GetResult_Response_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Sample_Patrol_GetResult_Response_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Sample_Patrol_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Sample_Patrol_GetResult_Response_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Sample_Patrol_GetResult_Response_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Sample_Patrol_GetResult_Response_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Sample_Patrol_GetResult_Response_& instance) = 0;

            protected:
                Sample_Patrol_GetResult_Response_DataReaderView () {};
                ~Sample_Patrol_GetResult_Response_DataReaderView () {};
            private:
                Sample_Patrol_GetResult_Response_DataReaderView (const Sample_Patrol_GetResult_Response_DataReaderView &);
                Sample_Patrol_GetResult_Response_DataReaderView & operator = (const Sample_Patrol_GetResult_Response_DataReaderView &);
            };
            class Patrol_Feedback_TypeSupportInterface;

            typedef Patrol_Feedback_TypeSupportInterface * Patrol_Feedback_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Feedback_TypeSupportInterface> Patrol_Feedback_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Patrol_Feedback_TypeSupportInterface> Patrol_Feedback_TypeSupportInterface_out;


            class Patrol_Feedback_DataWriter;

            typedef Patrol_Feedback_DataWriter * Patrol_Feedback_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Feedback_DataWriter> Patrol_Feedback_DataWriter_var;
            typedef DDS_DCPSInterface_out < Patrol_Feedback_DataWriter> Patrol_Feedback_DataWriter_out;


            class Patrol_Feedback_DataReader;

            typedef Patrol_Feedback_DataReader * Patrol_Feedback_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Feedback_DataReader> Patrol_Feedback_DataReader_var;
            typedef DDS_DCPSInterface_out < Patrol_Feedback_DataReader> Patrol_Feedback_DataReader_out;


            class Patrol_Feedback_DataReaderView;

            typedef Patrol_Feedback_DataReaderView * Patrol_Feedback_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Patrol_Feedback_DataReaderView> Patrol_Feedback_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Patrol_Feedback_DataReaderView> Patrol_Feedback_DataReaderView_out;

            struct Patrol_Feedback_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Patrol_Feedback_, struct Patrol_Feedback_Seq_uniq_> Patrol_Feedback_Seq;
            typedef DDS_DCPSSequence_var < Patrol_Feedback_Seq> Patrol_Feedback_Seq_var;
            typedef DDS_DCPSSequence_out < Patrol_Feedback_Seq> Patrol_Feedback_Seq_out;

            class  Patrol_Feedback_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Patrol_Feedback_TypeSupportInterface_ptr _ptr_type;
                typedef Patrol_Feedback_TypeSupportInterface_var _var_type;

                static Patrol_Feedback_TypeSupportInterface_ptr _duplicate (Patrol_Feedback_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Feedback_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Feedback_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Feedback_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Feedback_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Patrol_Feedback_TypeSupportInterface () {};
                ~Patrol_Feedback_TypeSupportInterface () {};
            private:
                Patrol_Feedback_TypeSupportInterface (const Patrol_Feedback_TypeSupportInterface &);
                Patrol_Feedback_TypeSupportInterface & operator = (const Patrol_Feedback_TypeSupportInterface &);
            };

            class  Patrol_Feedback_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Patrol_Feedback_DataWriter_ptr _ptr_type;
                typedef Patrol_Feedback_DataWriter_var _var_type;

                static Patrol_Feedback_DataWriter_ptr _duplicate (Patrol_Feedback_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Feedback_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Feedback_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Feedback_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Feedback_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Patrol_Feedback_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Patrol_Feedback_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Patrol_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Patrol_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Patrol_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Patrol_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Patrol_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Patrol_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Patrol_Feedback_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Patrol_Feedback_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Patrol_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_Feedback_& instance_data) = 0;

            protected:
                Patrol_Feedback_DataWriter () {};
                ~Patrol_Feedback_DataWriter () {};
            private:
                Patrol_Feedback_DataWriter (const Patrol_Feedback_DataWriter &);
                Patrol_Feedback_DataWriter & operator = (const Patrol_Feedback_DataWriter &);
            };

            class  Patrol_Feedback_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Patrol_Feedback_DataReader_ptr _ptr_type;
                typedef Patrol_Feedback_DataReader_var _var_type;

                static Patrol_Feedback_DataReader_ptr _duplicate (Patrol_Feedback_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Feedback_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Feedback_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Feedback_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Feedback_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_Feedback_& instance) = 0;

            protected:
                Patrol_Feedback_DataReader () {};
                ~Patrol_Feedback_DataReader () {};
            private:
                Patrol_Feedback_DataReader (const Patrol_Feedback_DataReader &);
                Patrol_Feedback_DataReader & operator = (const Patrol_Feedback_DataReader &);
            };

            class  Patrol_Feedback_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Patrol_Feedback_DataReaderView_ptr _ptr_type;
                typedef Patrol_Feedback_DataReaderView_var _var_type;

                static Patrol_Feedback_DataReaderView_ptr _duplicate (Patrol_Feedback_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_Feedback_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_Feedback_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_Feedback_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_Feedback_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_Feedback_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_Feedback_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_Feedback_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_Feedback_& instance) = 0;

            protected:
                Patrol_Feedback_DataReaderView () {};
                ~Patrol_Feedback_DataReaderView () {};
            private:
                Patrol_Feedback_DataReaderView (const Patrol_Feedback_DataReaderView &);
                Patrol_Feedback_DataReaderView & operator = (const Patrol_Feedback_DataReaderView &);
            };
            class Patrol_FeedbackMessage_TypeSupportInterface;

            typedef Patrol_FeedbackMessage_TypeSupportInterface * Patrol_FeedbackMessage_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Patrol_FeedbackMessage_TypeSupportInterface> Patrol_FeedbackMessage_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Patrol_FeedbackMessage_TypeSupportInterface> Patrol_FeedbackMessage_TypeSupportInterface_out;


            class Patrol_FeedbackMessage_DataWriter;

            typedef Patrol_FeedbackMessage_DataWriter * Patrol_FeedbackMessage_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Patrol_FeedbackMessage_DataWriter> Patrol_FeedbackMessage_DataWriter_var;
            typedef DDS_DCPSInterface_out < Patrol_FeedbackMessage_DataWriter> Patrol_FeedbackMessage_DataWriter_out;


            class Patrol_FeedbackMessage_DataReader;

            typedef Patrol_FeedbackMessage_DataReader * Patrol_FeedbackMessage_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Patrol_FeedbackMessage_DataReader> Patrol_FeedbackMessage_DataReader_var;
            typedef DDS_DCPSInterface_out < Patrol_FeedbackMessage_DataReader> Patrol_FeedbackMessage_DataReader_out;


            class Patrol_FeedbackMessage_DataReaderView;

            typedef Patrol_FeedbackMessage_DataReaderView * Patrol_FeedbackMessage_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Patrol_FeedbackMessage_DataReaderView> Patrol_FeedbackMessage_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Patrol_FeedbackMessage_DataReaderView> Patrol_FeedbackMessage_DataReaderView_out;

            struct Patrol_FeedbackMessage_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Patrol_FeedbackMessage_, struct Patrol_FeedbackMessage_Seq_uniq_> Patrol_FeedbackMessage_Seq;
            typedef DDS_DCPSSequence_var < Patrol_FeedbackMessage_Seq> Patrol_FeedbackMessage_Seq_var;
            typedef DDS_DCPSSequence_out < Patrol_FeedbackMessage_Seq> Patrol_FeedbackMessage_Seq_out;

            class  Patrol_FeedbackMessage_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Patrol_FeedbackMessage_TypeSupportInterface_ptr _ptr_type;
                typedef Patrol_FeedbackMessage_TypeSupportInterface_var _var_type;

                static Patrol_FeedbackMessage_TypeSupportInterface_ptr _duplicate (Patrol_FeedbackMessage_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_FeedbackMessage_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_FeedbackMessage_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_FeedbackMessage_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_FeedbackMessage_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Patrol_FeedbackMessage_TypeSupportInterface () {};
                ~Patrol_FeedbackMessage_TypeSupportInterface () {};
            private:
                Patrol_FeedbackMessage_TypeSupportInterface (const Patrol_FeedbackMessage_TypeSupportInterface &);
                Patrol_FeedbackMessage_TypeSupportInterface & operator = (const Patrol_FeedbackMessage_TypeSupportInterface &);
            };

            class  Patrol_FeedbackMessage_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Patrol_FeedbackMessage_DataWriter_ptr _ptr_type;
                typedef Patrol_FeedbackMessage_DataWriter_var _var_type;

                static Patrol_FeedbackMessage_DataWriter_ptr _duplicate (Patrol_FeedbackMessage_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_FeedbackMessage_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_FeedbackMessage_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_FeedbackMessage_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_FeedbackMessage_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Patrol_FeedbackMessage_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Patrol_FeedbackMessage_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Patrol_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Patrol_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Patrol_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Patrol_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Patrol_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Patrol_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Patrol_FeedbackMessage_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Patrol_FeedbackMessage_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Patrol_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_FeedbackMessage_& instance_data) = 0;

            protected:
                Patrol_FeedbackMessage_DataWriter () {};
                ~Patrol_FeedbackMessage_DataWriter () {};
            private:
                Patrol_FeedbackMessage_DataWriter (const Patrol_FeedbackMessage_DataWriter &);
                Patrol_FeedbackMessage_DataWriter & operator = (const Patrol_FeedbackMessage_DataWriter &);
            };

            class  Patrol_FeedbackMessage_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Patrol_FeedbackMessage_DataReader_ptr _ptr_type;
                typedef Patrol_FeedbackMessage_DataReader_var _var_type;

                static Patrol_FeedbackMessage_DataReader_ptr _duplicate (Patrol_FeedbackMessage_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_FeedbackMessage_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_FeedbackMessage_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_FeedbackMessage_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_FeedbackMessage_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_FeedbackMessage_& instance) = 0;

            protected:
                Patrol_FeedbackMessage_DataReader () {};
                ~Patrol_FeedbackMessage_DataReader () {};
            private:
                Patrol_FeedbackMessage_DataReader (const Patrol_FeedbackMessage_DataReader &);
                Patrol_FeedbackMessage_DataReader & operator = (const Patrol_FeedbackMessage_DataReader &);
            };

            class  Patrol_FeedbackMessage_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Patrol_FeedbackMessage_DataReaderView_ptr _ptr_type;
                typedef Patrol_FeedbackMessage_DataReaderView_var _var_type;

                static Patrol_FeedbackMessage_DataReaderView_ptr _duplicate (Patrol_FeedbackMessage_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Patrol_FeedbackMessage_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Patrol_FeedbackMessage_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Patrol_FeedbackMessage_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Patrol_FeedbackMessage_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Patrol_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Patrol_FeedbackMessage_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Patrol_FeedbackMessage_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Patrol_FeedbackMessage_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Patrol_FeedbackMessage_& instance) = 0;

            protected:
                Patrol_FeedbackMessage_DataReaderView () {};
                ~Patrol_FeedbackMessage_DataReaderView () {};
            private:
                Patrol_FeedbackMessage_DataReaderView (const Patrol_FeedbackMessage_DataReaderView &);
                Patrol_FeedbackMessage_DataReaderView & operator = (const Patrol_FeedbackMessage_DataReaderView &);
            };
        }

    }

}

#endif
