#ifndef _H_36118F018556E68E119321233E5C5C5F_Sound__H_
#define _H_36118F018556E68E119321233E5C5C5F_Sound__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace turtlebot3_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Sound_Constants
            {
                const ::DDS::Octet OFF_ = 0;

                const ::DDS::Octet ON_ = 1;

                const ::DDS::Octet LOW_BATTERY_ = 2;

                const ::DDS::Octet ERROR_ = 3;

                const ::DDS::Octet BUTTON1_ = 4;

                const ::DDS::Octet BUTTON2_ = 5;

            }

            struct  Sound_
            {
                ::DDS::Octet value_;
            };

            typedef DDS_DCPSStruct_var<Sound_> Sound__var;
            typedef Sound_& Sound__out;

        }

    }

}

#endif /* _H_36118F018556E68E119321233E5C5C5F_Sound__H_ */
