#ifndef _H_49642F3D0FE5E02267CDAF4804DFEAEC_Sound__H_
#define _H_49642F3D0FE5E02267CDAF4804DFEAEC_Sound__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace turtlebot3_msgs
{
    namespace srv
    {
        namespace dds_
        {
            struct  Sound_Request_
            {
                ::DDS::Octet value_;
            };

            typedef DDS_DCPSStruct_var<Sound_Request_> Sound_Request__var;
            typedef Sound_Request_& Sound_Request__out;

            struct  Sound_Response_
            {
                ::DDS::Boolean success_;
                ::DDS::String_mgr message_;
            };

            typedef DDS_DCPSStruct_var<Sound_Response_> Sound_Response__var;
            typedef DDS_DCPSStruct_out < Sound_Response_> Sound_Response__out;

            struct  Sample_Sound_Request_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::turtlebot3_msgs::srv::dds_::Sound_Request_ request_;
            };

            typedef DDS_DCPSStruct_var<Sample_Sound_Request_> Sample_Sound_Request__var;
            typedef Sample_Sound_Request_& Sample_Sound_Request__out;

            struct  Sample_Sound_Response_
            {
                ::DDS::ULongLong client_guid_0_;
                ::DDS::ULongLong client_guid_1_;
                ::DDS::LongLong sequence_number_;
                ::turtlebot3_msgs::srv::dds_::Sound_Response_ response_;
            };

            typedef DDS_DCPSStruct_var<Sample_Sound_Response_> Sample_Sound_Response__var;
            typedef DDS_DCPSStruct_out < Sample_Sound_Response_> Sample_Sound_Response__out;

        }

    }

}

#endif /* _H_49642F3D0FE5E02267CDAF4804DFEAEC_Sound__H_ */
